package model.cellule.créateur;

import javafx.beans.property.ListProperty;
import javafx.beans.property.SimpleListProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import model.cellule.Cellule;

import java.util.LinkedList;
import java.util.List;

public class CreateurCellule implements ICreateurCellule {
	private int w;
	private int h;

	public CreateurCellule(int w, int h) throws IllegalArgumentException{
		if(w < 0 || h<0){
			throw new IllegalArgumentException("La longueur et la largeur doivent être supperieur à 0");
		}
		this.w = w;
		this.h = h;
	}
	public ListProperty<List<Cellule>> creerCellules(){
		return creerCellules(w, h);
	}

	public ListProperty<List<Cellule>> creerCellules(int w, int h){
		ObservableList<List<Cellule>> cellsInit = FXCollections.observableArrayList();
		ListProperty<List<Cellule>> cells = new SimpleListProperty<>(cellsInit);
		List<Cellule> tmp;
		for (int i = 0; i < h; i++) {
			tmp = new LinkedList<>();
			for (int j = 0; j < w; j++) {
				tmp.add(new Cellule(j, i));
			}
			cells.add(tmp);
		}
		return cells;
	}
	public List<Cellule> creerLigneCellule(int longeure){
		List<Cellule> cells = new LinkedList<>();
		for(int i=0; i<longeure; ++i){
			cells.add(new Cellule(i, longeure));
		}
		++h;
		return cells;
	}
}
